import { File, FileSystem, Directory, ShallowDirectory } from './api';
import { InternalEventsEmitter } from "./utils";
export declare const noConnectionError = "WampClientFileSystem hasn't opened connection yet (forgot to init()?).";
export declare class WampClientFileSystem implements FileSystem {
    baseUrl: string;
    private realm;
    private initTimeout;
    readonly events: InternalEventsEmitter;
    private connection;
    private session;
    private realmPrefix;
    constructor(baseUrl: string, realm: string, initTimeout?: number);
    init(): Promise<WampClientFileSystem>;
    saveFile(fullPath: string, newContent: string): Promise<void>;
    deleteFile(fullPath: string): Promise<void>;
    deleteDirectory(fullPath: string, recursive?: boolean): Promise<void>;
    ensureDirectory(fullPath: string): Promise<void>;
    loadTextFile(fullPath: string): Promise<string>;
    loadDirectoryTree(fullPath?: string): Promise<Directory>;
    loadDirectoryChildren(fullPath: string): Promise<(File | ShallowDirectory)[]>;
    dispose(): void;
    private throwIfDisconnected();
}
